package Museum is

   ------------------------------------------
   --  the Museum abstraction is represented by
   --  the anonymous instance (i.e. one that has
   --  no defined type) "Guardian"
   --+
   --  visiting tourists apply to the Guardian
   --  to obtain access permission
   --+
   --  access is granted to groups of a fixed size
   --  (denoted by the private value Group_Size)
   --  but only strictly within capacity
   ------------------------------------------

   protected Guardian is
      entry Enter;
      procedure Leave;
   private
      function Is_Free return Boolean;
      Release : Boolean := False;
      Inside  : Natural := 0; -- must not exceed Capacity
   end Guardian;

private
   Capacity   : constant Positive := 7; -- must be >= Group_Size
   Group_Size : constant Positive := 3; -- must be <= Capacity
end Museum;
